
_Main_Init:

;electronique_diviseur_frequence_001_16f628.mpas,57 :: 		begin
;electronique_diviseur_frequence_001_16f628.mpas,58 :: 		CMCON := 7;  // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_diviseur_frequence_001_16f628.mpas,59 :: 		TRISA := %11101111;  // $EF - RA4 as output, other pins of PortA as input
	MOVLW      239
	MOVWF      TRISA+0
;electronique_diviseur_frequence_001_16f628.mpas,60 :: 		TRISB := $FF;  // all bits of PortB as input
	MOVLW      255
	MOVWF      TRISB+0
;electronique_diviseur_frequence_001_16f628.mpas,61 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_diviseur_frequence_001_16f628.mpas,62 :: 		OPTION_REG.NOT_RBPU := 1;  // disable pullup
	BSF        OPTION_REG+0, 7
;electronique_diviseur_frequence_001_16f628.mpas,63 :: 		INTCON := 0;
	CLRF       INTCON+0
;electronique_diviseur_frequence_001_16f628.mpas,64 :: 		INTCON.GIE := 1;
	BSF        INTCON+0, 7
;electronique_diviseur_frequence_001_16f628.mpas,65 :: 		INTCON.INTE := 1;
	BSF        INTCON+0, 4
;electronique_diviseur_frequence_001_16f628.mpas,66 :: 		INTCON.INTF := 0;
	BCF        INTCON+0, 1
;electronique_diviseur_frequence_001_16f628.mpas,67 :: 		PORTA := 0;  // clear portA
	CLRF       PORTA+0
;electronique_diviseur_frequence_001_16f628.mpas,68 :: 		PORTB := 0;  // clear portB
	CLRF       PORTB+0
;electronique_diviseur_frequence_001_16f628.mpas,69 :: 		bClockIn := false;
	CLRF       _bClockIn+0
;electronique_diviseur_frequence_001_16f628.mpas,70 :: 		iClkCount := 0;
	CLRF       _iClkCount+0
	CLRF       _iClkCount+1
;electronique_diviseur_frequence_001_16f628.mpas,71 :: 		iDivRate := 2;
	MOVLW      2
	MOVWF      _iDivRate+0
	CLRF       _iDivRate+1
;electronique_diviseur_frequence_001_16f628.mpas,72 :: 		end;
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_diviseur_frequence_001_16f628.mpas,75 :: 		begin
;electronique_diviseur_frequence_001_16f628.mpas,76 :: 		if INTCON.INTF = 1 then
	BTFSS      INTCON+0, 1
	GOTO       L__Interrupt3
;electronique_diviseur_frequence_001_16f628.mpas,78 :: 		OPTION_REG.INTEDG := OPTION_REG.INTEDG xor 1;  // invert rising / falling
	MOVLW      64
	XORWF      OPTION_REG+0, 1
;electronique_diviseur_frequence_001_16f628.mpas,80 :: 		bClockIn := true;
	MOVLW      255
	MOVWF      _bClockIn+0
;electronique_diviseur_frequence_001_16f628.mpas,81 :: 		INTCON.INTF := 0;  // clear RB Int Flag
	BCF        INTCON+0, 1
;electronique_diviseur_frequence_001_16f628.mpas,82 :: 		end;
L__Interrupt3:
;electronique_diviseur_frequence_001_16f628.mpas,83 :: 		end;
L__Interrupt48:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Main_GetDivRate:

;electronique_diviseur_frequence_001_16f628.mpas,86 :: 		begin
;electronique_diviseur_frequence_001_16f628.mpas,87 :: 		iDivRate := 0;
	CLRF       _iDivRate+0
	CLRF       _iDivRate+1
;electronique_diviseur_frequence_001_16f628.mpas,88 :: 		if In_Div_0 = 1 then iDivRate := iDivRate + 1;
	BTFSS      RA0_bit+0, 0
	GOTO       L__Main_GetDivRate7
	INCF       _iDivRate+0, 1
	BTFSC      STATUS+0, 2
	INCF       _iDivRate+1, 1
L__Main_GetDivRate7:
;electronique_diviseur_frequence_001_16f628.mpas,89 :: 		if In_Div_1 = 1 then iDivRate := iDivRate + 2;
	BTFSS      RA1_bit+0, 1
	GOTO       L__Main_GetDivRate10
	MOVLW      2
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate10:
;electronique_diviseur_frequence_001_16f628.mpas,90 :: 		if In_Div_2 = 1 then iDivRate := iDivRate + 4;
	BTFSS      RA2_bit+0, 2
	GOTO       L__Main_GetDivRate13
	MOVLW      4
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate13:
;electronique_diviseur_frequence_001_16f628.mpas,91 :: 		if In_Div_3 = 1 then iDivRate := iDivRate + 8;
	BTFSS      RA3_bit+0, 3
	GOTO       L__Main_GetDivRate16
	MOVLW      8
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate16:
;electronique_diviseur_frequence_001_16f628.mpas,92 :: 		if In_Div_4 = 1 then iDivRate := iDivRate + 16;
	BTFSS      RB1_bit+0, 1
	GOTO       L__Main_GetDivRate19
	MOVLW      16
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate19:
;electronique_diviseur_frequence_001_16f628.mpas,93 :: 		if In_Div_5 = 1 then iDivRate := iDivRate + 32;
	BTFSS      RB2_bit+0, 2
	GOTO       L__Main_GetDivRate22
	MOVLW      32
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate22:
;electronique_diviseur_frequence_001_16f628.mpas,94 :: 		if In_Div_6 = 1 then iDivRate := iDivRate + 64;
	BTFSS      RB3_bit+0, 3
	GOTO       L__Main_GetDivRate25
	MOVLW      64
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate25:
;electronique_diviseur_frequence_001_16f628.mpas,95 :: 		if In_Div_7 = 1 then iDivRate := iDivRate + 128;
	BTFSS      RB4_bit+0, 4
	GOTO       L__Main_GetDivRate28
	MOVLW      128
	ADDWF      _iDivRate+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDivRate+1, 1
L__Main_GetDivRate28:
;electronique_diviseur_frequence_001_16f628.mpas,96 :: 		if In_Div_8 = 1 then iDivRate := iDivRate + 256;
	BTFSS      RB5_bit+0, 5
	GOTO       L__Main_GetDivRate31
	MOVLW      0
	ADDWF      _iDivRate+0, 1
	MOVLW      1
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _iDivRate+1, 1
L__Main_GetDivRate31:
;electronique_diviseur_frequence_001_16f628.mpas,97 :: 		if In_Div_9 = 1 then iDivRate := iDivRate + 512;
	BTFSS      RB6_bit+0, 6
	GOTO       L__Main_GetDivRate34
	MOVLW      0
	ADDWF      _iDivRate+0, 1
	MOVLW      2
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _iDivRate+1, 1
L__Main_GetDivRate34:
;electronique_diviseur_frequence_001_16f628.mpas,98 :: 		end;
	RETURN
; end of _Main_GetDivRate

_main:

;electronique_diviseur_frequence_001_16f628.mpas,101 :: 		begin
;electronique_diviseur_frequence_001_16f628.mpas,102 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_diviseur_frequence_001_16f628.mpas,103 :: 		Main_GetDivRate;
	CALL       _Main_GetDivRate+0
;electronique_diviseur_frequence_001_16f628.mpas,105 :: 		while true do
L__main38:
;electronique_diviseur_frequence_001_16f628.mpas,109 :: 		if bClockIn then
	MOVF       _bClockIn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main43
;electronique_diviseur_frequence_001_16f628.mpas,112 :: 		inc(iClkCount);
	INCF       _iClkCount+0, 1
	BTFSC      STATUS+0, 2
	INCF       _iClkCount+1, 1
;electronique_diviseur_frequence_001_16f628.mpas,114 :: 		if iClkCount >= iDivRate then
	MOVF       _iDivRate+1, 0
	SUBWF      _iClkCount+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main49
	MOVF       _iDivRate+0, 0
	SUBWF      _iClkCount+0, 0
L__main49:
	BTFSS      STATUS+0, 0
	GOTO       L__main46
;electronique_diviseur_frequence_001_16f628.mpas,116 :: 		Out_Clk := Out_Clk xor $01;
	MOVLW      16
	XORWF      RA4_bit+0, 1
;electronique_diviseur_frequence_001_16f628.mpas,118 :: 		iClkCount := 0;
	CLRF       _iClkCount+0
	CLRF       _iClkCount+1
;electronique_diviseur_frequence_001_16f628.mpas,119 :: 		end;
L__main46:
;electronique_diviseur_frequence_001_16f628.mpas,121 :: 		bClockIn := false;
	CLRF       _bClockIn+0
;electronique_diviseur_frequence_001_16f628.mpas,122 :: 		end;
L__main43:
;electronique_diviseur_frequence_001_16f628.mpas,134 :: 		end;
	GOTO       L__main38
;electronique_diviseur_frequence_001_16f628.mpas,135 :: 		end.
	GOTO       $+0
; end of _main
